#include <sicppsdk.h>
#include <xsi_decl.h>
#include <xsi_parameter.h>
#include <xsi_geometry.h>
#include <xsi_math.h>
#include <xsi_primitive.h>
#include <xsi_point.h>
#include <xsi_operator.h>
#include <xsi_outputport.h>
#include <xsi_inputport.h>
#include <xsi_updatecontext.h>
#include <xsi_application.h>
#include <xsi_polygonmesh.h>
#include <xsi_polygonface.h> 
#include <xsi_triangle.h> 
#include <xsi_edge.h> 
#include <xsi_vertex.h> 
#include <xsi_vector3.h> 
#include <xsi_trianglevertex.h> 

#include "syForce.h"

using namespace XSI;
using namespace MATH;

//-------------------------------------------------------
void syXset(
	UpdateContext& ctx,
  syXforce *data
);
syXforce* syXdel(
	UpdateContext& ctx
);
syXforce* syXget(
	UpdateContext& ctx
);
//-------------------------------------------------------
syForceX::syForceX() {
  force = new syForceS;
  user_data = 0;
}
syForceX::~syForceX() {
  delete force;
}
//-------------------------------------------------------
#ifdef UNIX
extern "C"
#endif
CStatus syForce_Init(
	UpdateContext& ctx,
  long in_loadState 
) {
  syForceX *data = new syForceX;
  syXset( ctx, (syXforce*)data );
  
  return CStatus::OK;
}
//-------------------------------------------------------
#ifdef UNIX
extern "C"
#endif
CStatus syForce_Term(
  UpdateContext& ctx,
  long in_loadState
) {
  syForceX *data = (syForceX*) syXdel( ctx );
  delete data;

	return CStatus::OK;
}
//-------------------------------------------------------
#ifdef UNIX
extern "C"
#endif
CStatus syForce_Update (
	UpdateContext& ctx,
	OutputPort& outPort
){
  syForceX *data;
  data = (syForceX*) syXget( ctx );
  if( data == 0 )
    return CStatus::OK;
  syForceS *force = (syForceS*)data->force;

  Operator op(ctx.GetOperator());

  // get inputs
  bool mute = op.GetParameterValue(L"mute");
  float k = op.GetParameterValue(L"K");

  force->active = !mute;
  force->k = k;

  return CStatus::OK;
}
